Gecode::PropCost Class Reference
Functionality by programming task » Programming actors

Propagation cost. More...

`#include <core.hpp>`

## Public Types

enum | ActualCost { AC_RECORD = 0 , AC_CRAZY_LO = 1 , AC_CRAZY_HI = 1 , AC_CUBIC_LO = 1 , AC_CUBIC_HI = 1 , AC_QUADRATIC_LO = 2 , AC_QUADRATIC_HI = 2 , AC_LINEAR_HI = 3 , AC_LINEAR_LO = 4 , AC_TERNARY_HI = 4 , AC_BINARY_HI = 5 , AC_TERNARY_LO = 5 , AC_BINARY_LO = 6 , AC_UNARY_LO = 6 , AC_UNARY_HI = 6 , AC_MAX = 6 }
| The actual cost values that are used. More...
enum | Mod { LO , HI }
| Propagation cost modifier. More...

## Static Public Member Functions

static PropCost | record (void)
| For recording information (no propagation allowed).
static PropCost | crazy (PropCost::Mod m, unsigned int n)
| Exponential complexity for modifier m and size measure n.
static PropCost | crazy (PropCost::Mod m, int n)
| Exponential complexity for modifier m and size measure n.
static PropCost | cubic (PropCost::Mod m, unsigned int n)
| Cubic complexity for modifier m and size measure n.
static PropCost | cubic (PropCost::Mod m, int n)
| Cubic complexity for modifier m and size measure n.
static PropCost | quadratic (PropCost::Mod m, unsigned int n)
| Quadratic complexity for modifier m and size measure n.
static PropCost | quadratic (PropCost::Mod m, int n)
| Quadratic complexity for modifier m and size measure n.
static PropCost | linear (PropCost::Mod m, unsigned int n)
| Linear complexity for modifier pcm and size measure n.
static PropCost | linear (PropCost::Mod m, int n)
| Linear complexity for modifier pcm and size measure n.
static PropCost | ternary (PropCost::Mod m)
| Three variables for modifier pcm.
static PropCost | binary (PropCost::Mod m)
| Two variables for modifier pcm.
static PropCost | unary (PropCost::Mod m)
| Single variable for modifier pcm.

## Public Attributes

ActualCost | ac
| Actual cost.

## Detailed Description

Propagation cost.

Definition at line 486 of file core.hpp.

## Member Enumeration Documentation

## ActualCost

enum Gecode::PropCost::ActualCost

The actual cost values that are used.

Enumerator
AC_RECORD | Reserved for recording information.
AC_CRAZY_LO | Exponential complexity, cheap.
AC_CRAZY_HI | Exponential complexity, expensive.
AC_CUBIC_LO | Cubic complexity, cheap.
AC_CUBIC_HI | Cubic complexity, expensive.
AC_QUADRATIC_LO | Quadratic complexity, cheap.
AC_QUADRATIC_HI | Quadratic complexity, expensive.
AC_LINEAR_HI | Linear complexity, expensive.
AC_LINEAR_LO | Linear complexity, cheap.
AC_TERNARY_HI | Three variables, expensive.
AC_BINARY_HI | Two variables, expensive.
AC_TERNARY_LO | Three variables, cheap.
AC_BINARY_LO | Two variables, cheap.
AC_UNARY_LO | Only single variable, cheap.
AC_UNARY_HI | Only single variable, expensive.
AC_MAX | Maximal cost value.

Definition at line 490 of file core.hpp.

## Mod

enum Gecode::PropCost::Mod

Propagation cost modifier.

Enumerator
LO | Cheap.
HI | Expensive.

Definition at line 512 of file core.hpp.

## Member Function Documentation

## record()

PropCost Gecode::PropCost::record | ( | void |  | ) |

inline static

For recording information (no propagation allowed).

Definition at line 4765 of file core.hpp.

## crazy() [1/2]

PropCost Gecode::PropCost::crazy | ( | PropCost::Mod | m,
|  | unsigned int | n )

inline static

Exponential complexity for modifier m and size measure n.

Definition at line 4769 of file core.hpp.

## crazy() [2/2]

PropCost Gecode::PropCost::crazy | ( | PropCost::Mod | m,
|  | int | n )

inline static

Exponential complexity for modifier m and size measure n.

Definition at line 4773 of file core.hpp.

## cubic() [1/2]

PropCost Gecode::PropCost::cubic | ( | PropCost::Mod | m,
|  | unsigned int | n )

inline static

Cubic complexity for modifier m and size measure n.

Definition at line 4778 of file core.hpp.

## cubic() [2/2]

PropCost Gecode::PropCost::cubic | ( | PropCost::Mod | m,
|  | int | n )

inline static

Cubic complexity for modifier m and size measure n.

Definition at line 4782 of file core.hpp.

## quadratic() [1/2]

PropCost Gecode::PropCost::quadratic | ( | PropCost::Mod | m,
|  | unsigned int | n )

inline static

Quadratic complexity for modifier m and size measure n.

Definition at line 4787 of file core.hpp.

## quadratic() [2/2]

PropCost Gecode::PropCost::quadratic | ( | PropCost::Mod | m,
|  | int | n )

inline static

Quadratic complexity for modifier m and size measure n.

Definition at line 4791 of file core.hpp.

## linear() [1/2]

PropCost Gecode::PropCost::linear | ( | PropCost::Mod | m,
|  | unsigned int | n )

inline static

Linear complexity for modifier pcm and size measure n.

Definition at line 4796 of file core.hpp.

## linear() [2/2]

PropCost Gecode::PropCost::linear | ( | PropCost::Mod | m,
|  | int | n )

inline static

Linear complexity for modifier pcm and size measure n.

Definition at line 4800 of file core.hpp.

## ternary()

PropCost Gecode::PropCost::ternary | ( | PropCost::Mod | m | ) |

inline static

Three variables for modifier pcm.

Definition at line 4805 of file core.hpp.

## binary()

PropCost Gecode::PropCost::binary | ( | PropCost::Mod | m | ) |

inline static

Two variables for modifier pcm.

Definition at line 4809 of file core.hpp.

## unary()

PropCost Gecode::PropCost::unary | ( | PropCost::Mod | m | ) |

inline static

Single variable for modifier pcm.

Definition at line 4813 of file core.hpp.

## Member Data Documentation

## ac

ActualCost Gecode::PropCost::ac

Actual cost.

Definition at line 509 of file core.hpp.

The documentation for this class was generated from the following file:

- gecode/kernel/core.hpp